Coin: SoDragger Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SoDragger Class Reference
Dragger Classes

The SoDragger class is the base class for all draggers. More...

`#include <Inventor/draggers/SoDragger.h>`

Inheritance diagram for SoDragger:

## Public Types
enum | ProjectorFrontSetting { FRONT , BACK , USE_PICK }
Public Types inherited from SoInteractionKit
enum | CacheEnabled { OFF , ON , AUTO }
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 , INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 , COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 , COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 , COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000 }

## Public Member Functions
virtual SoType | getTypeId (void) const
virtual const SoNodekitCatalog * | getNodekitCatalog (void) const
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
void | setProjectorEpsilon (const float epsilon)
float | getProjectorEpsilon (void) const
void | addStartCallback (SoDraggerCB *func, void *data=NULL)
void | removeStartCallback (SoDraggerCB *func, void *data=NULL)
void | addMotionCallback (SoDraggerCB *func, void *data=NULL)
void | removeMotionCallback (SoDraggerCB *func, void *data=NULL)
void | addFinishCallback (SoDraggerCB *func, void *data=NULL)
void | removeFinishCallback (SoDraggerCB *func, void *data=NULL)
void | addValueChangedCallback (SoDraggerCB *func, void *data=NULL)
void | removeValueChangedCallback (SoDraggerCB *func, void *data=NULL)
void | setMinGesture (int pixels)
int | getMinGesture (void) const
SbBool | enableValueChangedCallbacks (SbBool newval)
const SbMatrix & | getMotionMatrix (void)
void | addOtherEventCallback (SoDraggerCB *func, void *data=NULL)
void | removeOtherEventCallback (SoDraggerCB *func, void *data=NULL)
void | registerChildDragger (SoDragger *child)
void | unregisterChildDragger (SoDragger *child)
void | registerChildDraggerMovingIndependently (SoDragger *child)
void | unregisterChildDraggerMovingIndependently (SoDragger *child)
SbMatrix | getLocalToWorldMatrix (void)
SbMatrix | getWorldToLocalMatrix (void)
SbVec3f | getLocalStartingPoint (void)
SbVec3f | getWorldStartingPoint (void)
void | getPartToLocalMatrix (const SbName &partname, SbMatrix &parttolocalmatrix, SbMatrix &localtopartmatrix)
void | transformMatrixLocalToWorld (const SbMatrix &frommatrix, SbMatrix &tomatrix)
void | transformMatrixWorldToLocal (const SbMatrix &frommatrix, SbMatrix &tomatrix)
void | transformMatrixToLocalSpace (const SbMatrix &frommatrix, SbMatrix &tomatrix, const SbName &fromspacepartname)
virtual void | setMotionMatrix (const SbMatrix &newmatrix)
void | valueChanged (void)
const SbMatrix & | getStartMotionMatrix (void)
virtual void | saveStartParameters (void)
const SoPath * | getPickPath (void) const
const SoEvent * | getEvent (void) const
SoPath * | createPathToThis (void)
const SoPath * | getSurrogatePartPickedOwner (void) const
const SbName & | getSurrogatePartPickedName (void) const
const SoPath * | getSurrogatePartPickedPath (void) const
void | setStartingPoint (const SoPickedPoint *newpoint)
void | setStartingPoint (const SbVec3f &newpoint)
const SbViewVolume & | getViewVolume (void)
void | setViewVolume (const SbViewVolume &vol)
const SbViewportRegion & | getViewportRegion (void)
void | setViewportRegion (const SbViewportRegion &reg)
SoHandleEventAction * | getHandleEventAction (void) const
void | setHandleEventAction (SoHandleEventAction *newAction)
void | setTempPathToThis (const SoPath *somethingclose)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
void | workFieldsIntoTransform (SbMatrix &mtx)
void | setFrontOnProjector (ProjectorFrontSetting newval)
ProjectorFrontSetting | getFrontOnProjector (void) const
Public Member Functions inherited from SoInteractionKit
| SoInteractionKit (void)
virtual SbBool | setPartAsPath (const SbName &partname, SoPath *path)
virtual SbBool | setPartAsDefault (const SbName &partname, SoNode *node, SbBool onlyifdefault=TRUE)
virtual SbBool | setPartAsDefault (const SbName &partname, const SbName &nodename, SbBool onlyifdefault=TRUE)
SbBool | isPathSurrogateInMySubgraph (const SoPath *path, SoPath *&pathToOwner, SbName &surrogatename, SoPath *&surrogatepath, SbBool fillargs=TRUE)
SbBool | isPathSurrogateInMySubgraph (const SoPath *path)
virtual SbBool | setPart (const SbName &partname, SoNode *from)
Public Member Functions inherited from SoBaseKit
| SoBaseKit (void)
virtual SoNode * | getPart (const SbName &partname, SbBool makeifneeded)
SbString | getPartString (const SoBase *part)
virtual SoNodeKitPath * | createPathToPart (const SbName &partname, SbBool makeifneeded, const SoPath *pathtoextend=NULL)
SbBool | set (const char *namevaluepairliststring)
SbBool | set (const char *partnamestring, const char *parameterstring)
virtual void | doAction (SoAction *action)
virtual SoChildList * | getChildren (void) const
void | printDiagram (void)
void | printSubDiagram (const SbName &rootname, int level)
void | printTable (void)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | forceChildDrivenWriteRefs (SoOutput *out)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | pick (SoPickAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
SbUniqueId | getNodeId (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static void | setMinScale (float newminscale)
static float | getMinScale (void)
static void | workValuesIntoTransform (SbMatrix &mtx, const SbVec3f *translationptr, const SbRotation *rotationptr, const SbVec3f *scalefactorptr, const SbRotation *scaleorientationptr, const SbVec3f *centerptr)
static void | getTransformFast (SbMatrix &mtx, SbVec3f &translation, SbRotation &rotation, SbVec3f &scalefactor, SbRotation &scaleorientation, const SbVec3f &center)
static void | getTransformFast (SbMatrix &mtx, SbVec3f &translation, SbRotation &rotation, SbVec3f &scalefactor, SbRotation &scaleorientation)
static SbMatrix | appendTranslation (const SbMatrix &mtx, const SbVec3f &translation, const SbMatrix *conversion=NULL)
static SbMatrix | appendScale (const SbMatrix &mtx, const SbVec3f &scale, const SbVec3f &scalecenter, const SbMatrix *conversion=NULL)
static SbMatrix | appendRotation (const SbMatrix &mtx, const SbRotation &rot, const SbVec3f &rotcenter, const SbMatrix *conversion=NULL)
static void | initClass (void)
static void | initClasses (void)
Static Public Member Functions inherited from SoInteractionKit
static SoType | getClassTypeId (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | setSwitchValue (SoNode *node, const int newVal)
Static Public Member Functions inherited from SoBaseKit
static SoType | getClassTypeId (void)
static void | initClass (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static SbBool | isSearchingChildren (void)
static void | setSearchingChildren (const SbBool newval)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes
SoSFBool | isActive
Public Attributes inherited from SoInteractionKit
SoSFEnum | renderCaching
SoSFEnum | boundingBoxCaching
SoSFEnum | renderCulling
SoSFEnum | pickCulling

## Protected Member Functions
virtual const SoFieldData * | getFieldData (void) const
| SoDragger (void)
virtual | ~SoDragger (void)
SbVec2f | getNormalizedLocaterPosition (void)
SbVec2s | getLocaterPosition (void)
SbVec2s | getStartLocaterPosition (void) const
void | setStartLocaterPosition (SbVec2s p)
SbBool | isAdequateConstraintMotion (void)
virtual SbBool | shouldGrabBasedOnSurrogate (const SoPath *pickpath, const SoPath *surrogatepath)
void | setCameraInfo (SoAction *action)
virtual void | handleEvent (SoHandleEventAction *ha)
void | transferMotion (SoDragger *child)
void | setIgnoreInBbox (SbBool newval)
SbBool | isIgnoreInBbox (void)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
void | setActiveChildDragger (SoDragger *newchilddragger)
SoDragger * | getActiveChildDragger (void) const
virtual void | setDefaultOnNonWritingFields (void)
void | updateDraggerCache (const SoPath *path)
virtual const SoPickedPoint * | getPickedPointForStart (SoHandleEventAction *action)
Protected Member Functions inherited from SoInteractionKit
virtual | ~SoInteractionKit ()
virtual void | copyContents (const SoFieldContainer *fromFC, SbBool copyConnections)
virtual SbBool | setPart (const int partNum, SoNode *node)
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual SbBool | setAnyPartAsDefault (const SbName &partname, SoNode *node, SbBool anypart=TRUE, SbBool onlyifdefault=TRUE)
virtual SbBool | setAnyPartAsDefault (const SbName &partname, const SbName &nodename, SbBool anypart=TRUE, SbBool onlyifdefault=TRUE)
SbBool | setAnySurrogatePath (const SbName &name, SoPath *path, SbBool leafcheck=FALSE, SbBool publiccheck=FALSE)
virtual SbBool | setUpConnections (SbBool onoff, SbBool doitalways=FALSE)
void | connectSeparatorFields (SoSeparator *dest, SbBool onOff)
Protected Member Functions inherited from SoBaseKit
virtual | ~SoBaseKit ()
virtual SoNode * | addToCopyDict (void) const
SoGroup * | getContainerNode (const SbName &listname, SbBool makeifneeded=TRUE)
virtual SoNode * | getAnyPart (const SbName &partname, SbBool makeifneeded, SbBool leafcheck=FALSE, SbBool publiccheck=FALSE)
virtual SoNodeKitPath * | createPathToAnyPart (const SbName &partname, SbBool makeifneeded, SbBool leafcheck=FALSE, SbBool publiccheck=FALSE, const SoPath *pathtoextend=NULL)
virtual SbBool | setAnyPart (const SbName &partname, SoNode *from, SbBool anypart=TRUE)
void | createNodekitPartsList (void)
void | createFieldList (void)
virtual void | createDefaultParts (void)
const SoNodekitParts * | getNodekitPartsList (void) const
const SbList< SoSFNode * > & | getCatalogInstances (void) const
void | catalogError (void)
void | countMyFields (SoOutput *out)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions
static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
static void | childTransferMotionAndValueChangedCB (void *, SoDragger *)
static void | childValueChangedCB (void *, SoDragger *)
static void | childStartCB (void *, SoDragger *)
static void | childMotionCB (void *, SoDragger *)
static void | childFinishCB (void *, SoDragger *)
static void | childOtherEventCB (void *, SoDragger *)
Static Protected Member Functions inherited from SoInteractionKit
static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
static void | readDefaultParts (const char *fileName, const char defaultBuffer[], int defBufSize)
static void | fieldSensorCB (void *, SoSensor *)
Static Protected Member Functions inherited from SoBaseKit
static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Protected Attributes
SoSFNode | motionMatrix
Protected Attributes inherited from SoInteractionKit
SoSFNode | geomSeparator
SoSFNode | topSeparator
SoFieldSensor * | fieldSensor
SoSeparator * | oldTopSep
Protected Attributes inherited from SoBaseKit
SoSFNode | callbackList
SoChildList * | children
SbBool | connectionsSetUp
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn

## Additional Inherited Members
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoDragger class is the base class for all draggers.

Draggers is a mechanism used for letting the end-users of your application code interact with elements in 3D, by scaling, rotating or translating geometry or other instances in the scene (like cameras or light sources).

For a very thorough introduction and tutorial to the dragger classes and general concepts, we advise you to consult «The Inventor Mentor», ISBN 0-201-62495-8, chapter 15.

This is the common superclass for all dragger classes.

It holds the current motion matrix, and offers lots of convenience methods to build from for its subclasses – that is, the non-abstract dragger classes to use as nodes in your scene graph.

The motion matrix is used to modify the model matrix during traversal, and this is a common dragger mechanism – all draggers should update this during dragging.

A number of the Coin dragger classes have built-in convenience wrapper classes, called manipulators. See for instance the SoTrackballDragger / SoTrackballManip pair.

The matching manipulator class for any dragger class has basically two convenient additions to the functionality of the standalone dragger: 1) it makes swapping the dragger in and out of the scene graph very straightforward (something which is often done for draggers in 3D user interfaces), 2) it wraps up the dragger with SoSurroundScale and SoAntiSquish nodes where applicable, so the dragger geometry automatically scales up or down to match the geometry it influences.

This last functionality can also be duplicated in a rather straightforward manner outside of the context of a manipulator, as can be seen from the usage example in the SoSurroundScale class documentation.

The appearance of draggers can be modified by either using the SoDragger::setPart() method (see usage example below) or by setting up external Inventor-format files which the geometry parts are read from. The latter method can be done by setting the environment variable `SO_DRAGGER_DIR` to point to a directory with replacement geometry files. The name of the new files and the name of the nodes / sub-graphs with the replacement geometries must follow a rigid scheme. We advise you to look at the Coin source code directory Coin/data/draggerDefaults/ to see how the replacement geometry files should be named. Setting `SO_DRAGGER_DIR` to this directory and modifying the files there provides a convenient way to play around with new dragger geometry arrangements.

As mentioned above, SoDragger::setPart() can be used to modify the appearance of a dragger by changing its default geometry. One common technique is for instance to take advantage of this to use only parts of a dragger, by replacing / disabling the geometry that you don't want the end-user to interact with. The following code example shows how to remove the translation functionality of the SoTransformBoxDragger:

#include <Inventor/Qt/SoQt.h>
#include <Inventor/Qt/viewers/SoQtExaminerViewer.h>
#include <Inventor/draggers/SoTransformBoxDragger.h>
#include <Inventor/nodes/SoSeparator.h>
int
main(int argc, char ** argv)
{
QWidget * window = SoQt::init(argv[0]);
SoTransformBoxDragger * dragger = new SoTransformBoxDragger;
SbString str;
for (int i = 1; i <= 6; i++) {
str.sprintf("translator%d.translator", i);
dragger->setPart(str.getString(), new SoSeparator);
}
SoQtExaminerViewer * viewer = new SoQtExaminerViewer(window);
viewer->setSceneGraph(dragger);
viewer->show();
SoQt::show(window);
SoQt::mainLoop();
delete viewer;
return 0;
}
SbString
The SbString class is a string class with convenience functions for string operations.
Definition SbString.h:52
SbString::sprintf
SbString & sprintf(const char *formatstr,...)
Definition SbString.h:118
SbString::getString
const char * getString(void) const
Definition SbString.h:84
SoInteractionKit::setPart
virtual SbBool setPart(const SbName &partname, SoNode *from)
Definition SoInteractionKit.cpp:742
SoSeparator
The SoSeparator class is a state-preserving group node.
Definition SoSeparator.h:44
SoTransformBoxDragger
The SoTransformBoxDragger provides a box which can be translated, scaled and rotated.
Definition SoTransformBoxDragger.h:45

Draggers are also node kits, and below is the catalog structure for this top-level dragger class.

Nodekit structure (new entries versus parent class marked with arrow prefix):

    CLASS SoDragger
    -->"this"
          "callbackList"
          "topSeparator"
    -->      "motionMatrix"
             "geomSeparator"

(See SoBaseKit::printDiagram() for information about the output formatting.)

Detailed information on catalog parts:

    CLASS SoDragger
    PVT   "this",  SoDragger  ---
          "callbackList",  SoNodeKitListPart [ SoCallback, SoEventCallback ]
    PVT   "topSeparator",  SoSeparator  ---
    PVT   "motionMatrix",  SoMatrixTransform  ---
    PVT   "geomSeparator",  SoSeparator  ---

(See SoBaseKit::printTable() for information about the output formatting.)

## Member Enumeration Documentation

## ◆ ProjectorFrontSetting

enum SoDragger::ProjectorFrontSetting

Holds various settings for projectors, which might affect cylindrical and spherical based draggers. Specifies whether dragging should be based on the front or back of the sphere / cylinder, or if the picked point should be used to decide this.

Enumerator
FRONT | Always use front of projector.
BACK | Always use back of projector.
USE_PICK | Use picked point to decide front or back of projector.

## Constructor & Destructor Documentation

## ◆ SoDragger()

SoDragger::SoDragger | ( | void |  | ) |
| protected

A protected constructor for this abstract superclass for all Coin draggers.

## ◆ ~SoDragger()

SoDragger::~SoDragger | ( | void |  | ) |
| protectedvirtual

Virtual protected destructor.

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoDragger::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ getTypeId()

SoType SoDragger::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoInteractionKit.

Reimplemented in SoCenterballDragger, SoDirectionalLightDragger, SoDragPointDragger, SoHandleBoxDragger, SoJackDragger, SoPointLightDragger, SoRotateCylindricalDragger, SoRotateDiscDragger, SoRotateSphericalDragger, SoScale1Dragger, SoScale2Dragger, SoScale2UniformDragger, SoScaleUniformDragger, SoSpotLightDragger, SoTabBoxDragger, SoTabPlaneDragger, SoTrackballDragger, SoTransformBoxDragger, SoTransformerDragger, SoTranslate1Dragger, and SoTranslate2Dragger.

## ◆ getFieldDataPtr()

const SoFieldData ** SoDragger::getFieldDataPtr | ( | void |  | ) |
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## ◆ getFieldData()

const SoFieldData * SoDragger::getFieldData | ( | void |  | ) | const
| protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoInteractionKit.

Reimplemented in SoCenterballDragger, SoDirectionalLightDragger, SoDragPointDragger, SoHandleBoxDragger, SoJackDragger, SoPointLightDragger, SoRotateCylindricalDragger, SoRotateDiscDragger, SoRotateSphericalDragger, SoScale1Dragger, SoScale2Dragger, SoScale2UniformDragger, SoScaleUniformDragger, SoSpotLightDragger, SoTabBoxDragger, SoTabPlaneDragger, SoTrackballDragger, SoTransformBoxDragger, SoTransformerDragger, SoTranslate1Dragger, and SoTranslate2Dragger.

## ◆ getClassNodekitCatalog()

const SoNodekitCatalog * SoDragger::getClassNodekitCatalog | ( | void |  | ) |
| static

Returns the nodekit catalog which defines the layout of this class' kit.

## ◆ getNodekitCatalog()

const SoNodekitCatalog * SoDragger::getNodekitCatalog | ( | void |  | ) | const
| virtual

Returns the nodekit catalog which defines the layout of this class' kit.

Reimplemented from SoInteractionKit.

Reimplemented in SoCenterballDragger, SoDirectionalLightDragger, SoDragPointDragger, SoHandleBoxDragger, SoJackDragger, SoPointLightDragger, SoRotateCylindricalDragger, SoRotateDiscDragger, SoRotateSphericalDragger, SoScale1Dragger, SoScale2Dragger, SoScale2UniformDragger, SoScaleUniformDragger, SoSpotLightDragger, SoTabBoxDragger, SoTabPlaneDragger, SoTrackballDragger, SoTransformBoxDragger, SoTransformerDragger, SoTranslate1Dragger, and SoTranslate2Dragger.

## ◆ getClassNodekitCatalogPtr()

const SoNodekitCatalog ** SoDragger::getClassNodekitCatalogPtr | ( | void |  | ) |
| staticprotected

Returns the pointer to the pointer of the nodekit catalog for this class.

## ◆ callback()

void SoDragger::callback | ( | SoCallbackAction * | action | ) |
| virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoBaseKit.

## ◆ GLRender()

void SoDragger::GLRender | ( | SoGLRenderAction * | action | ) |
| virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoBaseKit.

Reimplemented in SoTabPlaneDragger.

## ◆ getMatrix()

void SoDragger::getMatrix | ( | SoGetMatrixAction * | action | ) |
| virtual

Action method for SoGetMatrixAction.

Updates action by accumulating with the transformation matrix of this node (if any).

Reimplemented from SoBaseKit.

Reimplemented in SoCenterballDragger.

## ◆ rayPick()

void SoDragger::rayPick | ( | SoRayPickAction * | action | ) |
| virtual

Action method for SoRayPickAction.

Checks the ray specification of the action and tests for intersection with the data of the node.

Nodes influencing relevant state variables for how picking is done also override this method.

Reimplemented from SoBaseKit.

## ◆ search()

void SoDragger::search | ( | SoSearchAction * | action | ) |
| virtual

Action method for SoSearchAction.

Compares the search criteria from the action to see if this node is a match. Searching is done by matching up all criteria set up in the SoSearchAction – if any of the requested criteria is a miss, the search is not deemed successful for the node.

See also
  SoSearchAction

Reimplemented from SoBaseKit.

## ◆ write()

void SoDragger::write | ( | SoWriteAction * | action | ) |
| virtual

Action method for SoWriteAction.

Writes out a node object, and any connected nodes, engines etc, if necessary.

Reimplemented from SoBaseKit.

## ◆ getPrimitiveCount()

void SoDragger::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) |
| virtual

Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoBaseKit.

## ◆ setProjectorEpsilon()

void SoDragger::setProjectorEpsilon | ( | const float | epsilon | ) |

Sets the epsilon used for restricting the draggers when the intersection line is almost parallel with the projector direction.

For line projectors this is based on the dot product between the picking ray and the projector line. For plane projector, the dot product between the plane normal and the picking ray is used.

Default value is 0.0.

Since
  Coin 3.0

## ◆ addStartCallback()

void SoDragger::addStartCallback | ( | SoDraggerCB * | func,
|  | void * | data = NULL )

Adds a callback which is called at the start of a drag, after the mouse button 1 is pressed, and dragger is picked.

## ◆ removeStartCallback()

void SoDragger::removeStartCallback | ( | SoDraggerCB * | func,
|  | void * | data = NULL )

Removes a previously registered start callback.

See also
  addStartCallback()

## ◆ addMotionCallback()

void SoDragger::addMotionCallback | ( | SoDraggerCB * | func,
|  | void * | data = NULL )

Adds a callback which is called for each mouse movement during dragging.

## ◆ removeMotionCallback()

void SoDragger::removeMotionCallback | ( | SoDraggerCB * | func,
|  | void * | data = NULL )

Removes a previously registered motion callback.

See also
  addMotionCallback()

## ◆ addFinishCallback()

void SoDragger::addFinishCallback | ( | SoDraggerCB * | func,
|  | void * | data = NULL )

Adds a callback which is called after dragging is finished.

## ◆ removeFinishCallback()

void SoDragger::removeFinishCallback | ( | SoDraggerCB * | func,
|  | void * | data = NULL )

Removes a finish callback.

See also
  addFinishCallback()

## ◆ addValueChangedCallback()

void SoDragger::addValueChangedCallback | ( | SoDraggerCB * | func,
|  | void * | data = NULL )

Adds a callback which is called after a dragger has changed a field. It is not called if the SoDragger::isActive field is changed.

See also
  enableValueChangedCallback()

## ◆ removeValueChangedCallback()

void SoDragger::removeValueChangedCallback | ( | SoDraggerCB * | func,
|  | void * | data = NULL )

Removes a value changed callback.

See also
  addValueChangedCallback()

## ◆ setMinGesture()

void SoDragger::setMinGesture | ( | int | pixels | ) |

Sets the number of pixel movement needed to trigger a constraint gesture. Default is 8 pixels.

## ◆ getMinGesture()

int SoDragger::getMinGesture | ( | void |  | ) | const

Returns the gesture pixels threshold value.

See also
  setMinGesture()

## ◆ enableValueChangedCallbacks()

SbBool SoDragger::enableValueChangedCallbacks | ( | SbBool | val | ) |

Enable or disable "value changed" callbacks.

See also
  addValueChangedCallback()

## ◆ getMotionMatrix()

const SbMatrix & SoDragger::getMotionMatrix | ( | void |  | ) |

Returns the motion matrix for this dragger.

## ◆ addOtherEventCallback()

void SoDragger::addOtherEventCallback | ( | SoDraggerCB * | func,
|  | void * | data = NULL )

Adds an event callback for events other then drag events. As soon as dragging starts, the dragger grabs all events (until mouse button is released). This method can be used to handle other events during dragging.

## ◆ removeOtherEventCallback()

void SoDragger::removeOtherEventCallback | ( | SoDraggerCB * | func,
|  | void * | data = NULL )

Removes a other event callback.

See also
  addOtherEventCallback()

## ◆ registerChildDragger()

void SoDragger::registerChildDragger | ( | SoDragger * | child | ) |

Should be called by compound draggers to register child draggers.

## ◆ unregisterChildDragger()

void SoDragger::unregisterChildDragger | ( | SoDragger * | child | ) |

Should be called by compound draggers to unregister child draggers.

## ◆ registerChildDraggerMovingIndependently()

void SoDragger::registerChildDraggerMovingIndependently | ( | SoDragger * | child | ) |

Should be called by compound draggers to register child draggers that should move independently of their parent.

## ◆ unregisterChildDraggerMovingIndependently()

void SoDragger::unregisterChildDraggerMovingIndependently | ( | SoDragger * | child | ) |

Should be called by compound draggers to unregister child draggers.

See also
  registerChildDraggerMovingIndependently()

## ◆ getLocalToWorldMatrix()

SbMatrix SoDragger::getLocalToWorldMatrix | ( | void |  | ) |

Returns a matrix that converts from local to world space.

## ◆ getWorldToLocalMatrix()

SbMatrix SoDragger::getWorldToLocalMatrix | ( | void |  | ) |

Returns a matrix that converts from world to local space.

## ◆ getLocalStartingPoint()

SbVec3f SoDragger::getLocalStartingPoint | ( | void |  | ) |

Returns the drag starting point in the local coordinate system.

## ◆ getWorldStartingPoint()

SbVec3f SoDragger::getWorldStartingPoint | ( | void |  | ) |

Returns the drag starting point in the world coordinate system.

## ◆ getPartToLocalMatrix()

void SoDragger::getPartToLocalMatrix | ( | const SbName & | partname,
|  | SbMatrix & | parttolocalmatrix,
|  | SbMatrix & | localtopartmatrix )

Returns matrices that will convert between local space and the space in which partname lies in.

## ◆ transformMatrixLocalToWorld()

void SoDragger::transformMatrixLocalToWorld | ( | const SbMatrix & | frommatrix,
|  | SbMatrix & | tomatrix )

Convenience method that transforms the local frommatrix to a world coordinate systems matrix.

## ◆ transformMatrixWorldToLocal()

void SoDragger::transformMatrixWorldToLocal | ( | const SbMatrix & | frommatrix,
|  | SbMatrix & | tomatrix )

Convenience method that transforms the world frommatrix to a local coordinate systems matrix.

## ◆ transformMatrixToLocalSpace()

void SoDragger::transformMatrixToLocalSpace | ( | const SbMatrix & | frommatrix,
|  | SbMatrix & | tomatrix,
|  | const SbName & | fromspacepartname )

Transforms a matrix that lies in the frompartname coordinate system into the local coordinate system.

## ◆ setMotionMatrix()

void SoDragger::setMotionMatrix | ( | const SbMatrix & | matrix | ) |
| virtual

Sets a new current motion matrix for the dragger geometry.

Triggers value changed callbacks if matrix is not equal to the previous motion matrix.

Reimplemented in SoTranslate1Dragger, and SoTranslate2Dragger.

## ◆ valueChanged()

void SoDragger::valueChanged | ( | void |  | ) |

Can be called by subclasses to trigger value changed callbacks. This might be needed if a field is changed without changing the motion matrix.

## ◆ getStartMotionMatrix()

const SbMatrix & SoDragger::getStartMotionMatrix | ( | void |  | ) |

Returns the motion matrix as it was when saveStartParameters() was called.

## ◆ saveStartParameters()

void SoDragger::saveStartParameters | ( | void |  | ) |
| virtual

This is invoked to save start parameters, to enable draggers to calculate relative motion.

Default method in superclass SoDragger just saves the motion matrix, but subclasses should overload this method if other data needs to be saved.

Reimplemented in SoCenterballDragger.

## ◆ getPickPath()

const SoPath * SoDragger::getPickPath | ( | void |  | ) | const

Returns the picked path.

## ◆ getEvent()

const SoEvent * SoDragger::getEvent | ( | void |  | ) | const

Returns the current event.

## ◆ createPathToThis()

SoPath * SoDragger::createPathToThis | ( | void |  | ) |

Creates a new path to this dragger. Don't forget to ref() and unref() since this method creates a fresh copy for you.

## ◆ getSurrogatePartPickedOwner()

const SoPath * SoDragger::getSurrogatePartPickedOwner | ( | void |  | ) | const

Returns the path to the SoInteractionKit that holds the current surrogate path.

## ◆ getSurrogatePartPickedName()

const SbName & SoDragger::getSurrogatePartPickedName | ( | void |  | ) | const

Returns the name of the path in the SoInteractionKit that holds the current surrogate path.

## ◆ getSurrogatePartPickedPath()

const SoPath * SoDragger::getSurrogatePartPickedPath | ( | void |  | ) | const

Returns the current surrogate path.

## ◆ setStartingPoint() [1/2]

void SoDragger::setStartingPoint | ( | const SoPickedPoint * | point | ) |

Sets the staring point for the drag. point is usually a picked point from a SoRayPickAction.

## ◆ setStartingPoint() [2/2]

void SoDragger::setStartingPoint | ( | const SbVec3f & | point | ) |

Sets the starting point for a drag.

## ◆ getViewVolume()

const SbViewVolume & SoDragger::getViewVolume | ( | void |  | ) |

Return the current view volume.

## ◆ setViewVolume()

void SoDragger::setViewVolume | ( | const SbViewVolume & | vv | ) |

Sets the current view volume.

## ◆ getViewportRegion()

const SbViewportRegion & SoDragger::getViewportRegion | ( | void |  | ) |

Returns the current viewport region.

## ◆ setViewportRegion()

void SoDragger::setViewportRegion | ( | const SbViewportRegion & | vp | ) |

Sets the current viewport region.

## ◆ getHandleEventAction()

SoHandleEventAction * SoDragger::getHandleEventAction | ( | void |  | ) | const

Return the current (most recent) SoHandleEventAction.

## ◆ setHandleEventAction()

void SoDragger::setHandleEventAction | ( | SoHandleEventAction * | action | ) |

Stores a handle event action.

## ◆ setTempPathToThis()

void SoDragger::setTempPathToThis | ( | const SoPath * | somethingclose | ) |

This function is part of the original SGI Inventor 2.1 API, but has not been implemented in Coin as it looks like a function which should probably have been private in Open Inventor.

## ◆ grabEventsSetup()

void SoDragger::grabEventsSetup | ( | void |  | ) |
| virtual

Called when dragger starts grabbing events (mouse button down). Overload if you need to do something extra in your dragger.

See also
  grabEventCleanup()

Reimplemented from SoNode.

## ◆ grabEventsCleanup()

void SoDragger::grabEventsCleanup | ( | void |  | ) |
| virtual

Called when dragger stops grabbing events (mouse button up).

See also
  grabEventSetup()

Reimplemented from SoNode.

## ◆ workFieldsIntoTransform()

void SoDragger::workFieldsIntoTransform | ( | SbMatrix & | matrix | ) |

Examines the fields of the dragger, changes the matrix according to those fields and leaves the rest of the matrix as it was. The following field names are supported: translation, scaleFactor, rotation and scaleOrientation.

## ◆ setFrontOnProjector()

void SoDragger::setFrontOnProjector | ( | ProjectorFrontSetting | val | ) |

Controls the behaviour of the SbProjector.

## ◆ getFrontOnProjector()

SoDragger::ProjectorFrontSetting SoDragger::getFrontOnProjector | ( | void |  | ) | const

Returns the behaviour of the SbProjector.

## ◆ setMinScale()

void SoDragger::setMinScale | ( | float | minscalearg | ) |
| static

Sets the minimum scale value all scale factors are clamped against. This is used in workFieldsIntoTransform(). The default value is 0.01

## ◆ getMinScale()

float SoDragger::getMinScale | ( | void |  | ) |
| static

Returns the minimum scale value.

See also
  setMinScale()

## ◆ workValuesIntoTransform()

void SoDragger::workValuesIntoTransform | ( | SbMatrix & | matrix,
|  | const SbVec3f * | translationptr,
|  | const SbRotation * | rotationptr,
|  | const SbVec3f * | scalefactorptr,
|  | const SbRotation * | scaleorientationptr,
|  | const SbVec3f * | centerptr )
| static

Same as above, but pointers to values are supplied. If a pointer is `NULL`, the matrix value for that argument is used when reconstructing the matrix.

## ◆ getTransformFast() [1/2]

void SoDragger::getTransformFast | ( | SbMatrix & | matrix,
|  | SbVec3f & | translation,
|  | SbRotation & | rotation,
|  | SbVec3f & | scalefactor,
|  | SbRotation & | scaleorientation,
|  | const SbVec3f & | center )
| static

Can be used when there is no scaleorientation. Faster than SoDragger::workValuesIntoTransform().

## ◆ getTransformFast() [2/2]

void SoDragger::getTransformFast | ( | SbMatrix & | matrix,
|  | SbVec3f & | translation,
|  | SbRotation & | rotation,
|  | SbVec3f & | scalefactor,
|  | SbRotation & | scaleorientation )
| static

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ appendTranslation()

SbMatrix SoDragger::appendTranslation | ( | const SbMatrix & | matrix,
|  | const SbVec3f & | translation,
|  | const SbMatrix * | conversion = NULL )
| static

Returns matrix after translation has been appended. If conversion != `NULL` it is used to transform translation into the space matrix is defined.

## ◆ appendScale()

SbMatrix SoDragger::appendScale | ( | const SbMatrix & | matrix,
|  | const SbVec3f & | scale,
|  | const SbVec3f & | scalecenter,
|  | const SbMatrix * | conversion = NULL )
| static

Returns matrix after scale and scalecenter have been appended. If conversion != `NULL` it is used to transform scale into the space matrix is defined.

## ◆ appendRotation()

SbMatrix SoDragger::appendRotation | ( | const SbMatrix & | matrix,
|  | const SbRotation & | rot,
|  | const SbVec3f & | rotcenter,
|  | const SbMatrix * | conversion = NULL )
| static

Appends rot, around rotcenter, to matrix. If conversion is != `NULL`, this is used to move the rotation into that coordinate systems before appending the rotation.

## ◆ initClass()

void SoDragger::initClass | ( | void |  | ) |
| static

Initializes type system for this dragger class.

Application programmers should usually not have to invoke this method, see documentation of SoInteraction::init().

## ◆ initClasses()

void SoDragger::initClasses | ( | void |  | ) |
| static

Initializes all built-in draggers.

## ◆ getNormalizedLocaterPosition()

SbVec2f SoDragger::getNormalizedLocaterPosition | ( | void |  | ) |
| protected

Returns the position of the locater.

## ◆ getLocaterPosition()

SbVec2s SoDragger::getLocaterPosition | ( | void |  | ) |
| protected

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ getStartLocaterPosition()

SbVec2s SoDragger::getStartLocaterPosition | ( | void |  | ) | const
| protected

Returns the position when mouse button 1 was pressed.

## ◆ setStartLocaterPosition()

void SoDragger::setStartLocaterPosition | ( | SbVec2s | pos | ) |
| protected

The start locater position is automatically set when mouse button 1 goes down, but subclasses can use this method to reset the value.

## ◆ isAdequateConstraintMotion()

SbBool SoDragger::isAdequateConstraintMotion | ( | void |  | ) |
| protected

Checks if the mouse pointer has been moved enough after the end-user hit a constraint mode key (which is typically `SHIFT`, sometimes also `CTRL` for the built-in draggers) that we should act upon and decide which direction the constraint should be set to.

## ◆ shouldGrabBasedOnSurrogate()

SbBool SoDragger::shouldGrabBasedOnSurrogate | ( | const SoPath * | pickpath,
|  | const SoPath * | surrogatepath )
| protectedvirtual

Checks if pickpath contains surrogatepath and returns `TRUE` if the tail of surrogatepath is before any dragger in pickpath.

## ◆ setCameraInfo()

void SoDragger::setCameraInfo | ( | SoAction * | action | ) |
| protected

Store data about the current camera in the given action.

## ◆ handleEvent()

void SoDragger::handleEvent | ( | SoHandleEventAction * | action | ) |
| protectedvirtual

Action method for SoHandleEventAction.

Inspects the event data from action, and processes it if it is something which this node should react to.

Nodes influencing relevant state variables for how event handling is done also override this method.

Reimplemented from SoBaseKit.

## ◆ transferMotion()

void SoDragger::transferMotion | ( | SoDragger * | child | ) |
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ setIgnoreInBbox()

void SoDragger::setIgnoreInBbox | ( | SbBool | val | ) |
| protected

Sets whether dragger geometry should be ignored when calculating bounding box.

## ◆ isIgnoreInBbox()

SbBool SoDragger::isIgnoreInBbox | ( | void |  | ) |
| protected

Returns whether dragger geometry should be ignored when calculating bounding box.

## ◆ getBoundingBox()

void SoDragger::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) |
| protectedvirtual

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculate their bounding box also override this method to change the relevant state variables.

Reimplemented from SoBaseKit.

Reimplemented in SoCenterballDragger.

## ◆ setActiveChildDragger()

void SoDragger::setActiveChildDragger | ( | SoDragger * | childdragger | ) |
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ getActiveChildDragger()

SoDragger * SoDragger::getActiveChildDragger | ( | void |  | ) | const
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ setDefaultOnNonWritingFields()

void SoDragger::setDefaultOnNonWritingFields | ( | void |  | ) |
| protectedvirtual

(Be aware that this method is unlikely to be of interest to the application programmer who does not want to extend the library with new custom nodekits or draggers. If you indeed are writing extensions, see the information in the SoBaseKit class documentation.)

This is a virtual method, and the code in it should call SoField::setDefault() with argument `TRUE` on part fields that should not be written upon scene graph export operations.

This is typically done when:

1. field value is `NULL` and part is `NULL` by default

2. it is a leaf SoGroup or SoSeparator node with no children

3. it is a leaf listpart with no children and an SoGroup or SoSeparator container

4. it is a non-leaf part and it is of SoGroup type and all fields are at their default values

Subclasses should usually override this to do additional settings for new member fields. From the subclass, do remember to call "upwards" to your superclass' setDefaultOnNonWritingFields() method.

Reimplemented from SoInteractionKit.

Reimplemented in SoCenterballDragger, SoDirectionalLightDragger, SoDragPointDragger, SoHandleBoxDragger, SoJackDragger, SoPointLightDragger, SoSpotLightDragger, SoTabBoxDragger, SoTabPlaneDragger, SoTrackballDragger, SoTransformBoxDragger, and SoTransformerDragger.

## ◆ childTransferMotionAndValueChangedCB()

void SoDragger::childTransferMotionAndValueChangedCB | ( | void * | data,
|  | SoDragger * | child )
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ childValueChangedCB()

void SoDragger::childValueChangedCB | ( | void * | data,
|  | SoDragger * | child )
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ childStartCB()

void SoDragger::childStartCB | ( | void * | data,
|  | SoDragger * | child )
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ childMotionCB()

void SoDragger::childMotionCB | ( | void * | data,
|  | SoDragger * | child )
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ childFinishCB()

void SoDragger::childFinishCB | ( | void * | data,
|  | SoDragger * | child )
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ childOtherEventCB()

void SoDragger::childOtherEventCB | ( | void * | data,
|  | SoDragger * | child )
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ updateDraggerCache()

void SoDragger::updateDraggerCache | ( | const SoPath * | path | ) |
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ getPickedPointForStart()

const SoPickedPoint * SoDragger::getPickedPointForStart | ( | SoHandleEventAction * | action | ) |
| protectedvirtual

Interaction with the dragger will be started, if the returned picked point belongs to the dragger. A derived class can override this method to change the condition when the dragger starts interaction, e.g. it can return the picked point on the dragger from the picked point list of the action, even if it is covered by other (semi) transparent objects. The default implementation returns the foremost picked point from the action. This method is not present in Open Inventor.

## Member Data Documentation

## ◆ isActive

SoSFBool SoDragger::isActive

Is `TRUE` whenever the user is interacting with the dragger. For compound draggers (draggers consisting of one or more subdraggers), the isActive field is updated only for the active subdragger, not for the compound dragger.

The documentation for this class was generated from the following files:

- SoDragger.h
- SoDragger.cpp